import sys
import os
import string
import subprocess

# KLUDGE: Is there a better way to get setuptools commands?
install = 'install' in sys.argv[1:]

def run_command(cmd):
    p = subprocess.Popen(cmd,shell = True)
    rc = p.wait()
    if rc:
        # KLUDGE: What should I do here?
        raise RuntimeError(cmd)

def install_redis(version = '2.6.13'):
    run_command(\
        'wget http://redis.googlecode.com/files/redis-{version}.tar.gz'
        .format(**locals()))
    run_command('tar xzf redis-{version}.tar.gz'.format(**locals()))
    os.chdir('redis-{version}'.format(**locals()))
    run_command('make install')
    os.chdir('..')
    run_command('rm -rf redis-{version}'.format(**locals()))
    run_command('rm redis-{version}.tar.gz'.format(**locals()))
    run_command('redis-server &')

def install_tornado():
    run_command('wget https://github.com/nephics/tornado/tarball/streambody --output-document tornado.tar.gz')
    run_command('mkdir tornado')
    run_command('tar xzf tornado.tar.gz -C tornado --strip-components 1')
    os.chdir('tornado')
    run_command('python setup.py install')
    os.chdir('..')
    run_command('rm -rf tornado')
    run_command('rm tornado.tar.gz')

def install_nginx(version = '1.4.1'):
    run_command(\
        'wget http://nginx.org/download/nginx-{version}.tar.gz'
        .format(**locals()))
    run_command('tar xzf nginx-{version}.tar.gz'.format(**locals()))
    dr = os.path.dirname(os.path.abspath(__file__))
    os.chdir('nginx-{version}'.format(**locals()))
    path = os.path.join(dr,'oliver/consistent_hash')
    run_command(\
        './configure --add-module={path_to_consistent_hash} --with-debug'
        .format(path_to_consistent_hash = path))
    run_command('make')
    run_command('make install')
    os.chdir('..')
    run_command('rm -rf nginx-{version}'.format(**locals()))
    run_command('rm nginx-{version}.tar.gz'.format(**locals()))

if install:
    # make dependencies.sh executable
    run_command('chmod a+x dependencies.sh')
    # install non-python dependencies
    run_command('./dependencies.sh')
    install_nginx()
    install_redis()
    install_tornado()

# build up the list of packages
packages = []
root_dir = os.path.dirname(__file__)
if root_dir != '':
    os.chdir(root_dir)
oliver_dir = 'oliver'

for dirpath, dirnames, filenames in os.walk(oliver_dir):
    if '__init__.py' in filenames:
        pathparts = dirpath.split(os.path.sep)
        index = pathparts.index(oliver_dir)
        packages.append(string.join(pathparts[index:],'.'))


def read(fname):
    '''
    This is yanked from the setuptools documentation at 
    http://packages.python.org/an_example_pypi_project/setuptools.html. It is
    used to read the text from the README file.
    '''
    return open(os.path.join(os.path.dirname(__file__), fname)).read()

from setuptools import setup

setup(
      name = 'oliver',
      version = '0.77',
      url = 'http://www.johnvinyard.com',
      author = 'John Vinyard',
      author_email = 'john.vinyard@gmail.com',
      long_description = read('README.md'),
      package_data = {
        'consistent_hash' : ['*'],
        ''                : ['*.json']
      },
      scripts = ['oliver/start_node.py'],
      include_package_data = True,
      packages = packages,
      # TODO: Why can't simplejson compile the C module?
      install_requires = ['nose','unittest2','redis==2.7.5','requests','argparse','simplejson']
)

if install:
    # run the unit tests
    run_command('nosetests --nologcapture')
    print 'Done! Enjoy oliver.'